Updated rip_dvd.conf sourcing algorithm in rip_dvd.wrap to match rip_dvd
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidvhq"
42 typeset extension=""
43 typeset mailto=""
44 typeset -i force_onepass_mode=0
45 typeset -i eject_disk=1
46 typeset -i keep_isofile=0
47 typeset -i keep_vobfile=0
48 typeset -i keep_dvdfolder=0
49 typeset -i keep_intermediate_files=0
50 typeset -i make_final_dest_vob=0
51 typeset -i make_final_dest_iso=0
52 typeset -i make_final_dest_folder=0
53 typeset -i make_final_dest_comp=0
54 typeset -i errors=0
55 typeset -i show_usage=0
56 typeset -i mirror_mode=0
57 typeset -i target_bitrate=2000
58 typeset -i target_size=0
59 typeset -i audio_2ch=0
60 typeset -i invalid_feature_title=0
61 typeset -i feature_title_override=0
62 typeset -i mplayer_dumpstream_incompatibility=0
63
64 ##############################################################################
65 # Local Machine Settings:
66 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
67 # and the local conf file created by each local machine (rip_dvd.conf)
68 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
69 # This will allow you to override all the default values to meet your needs
70 # in a way that won't get clobbered when you pull updates from my GIT repo.
71 ##############################################################################
72 config="${0%/*}/rip_dvd.conf"
73
74 # The config file will be searched for in the following location order:
75 found_config=0
76
77 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
78 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
79
80 # 2) /path/to/rip_dvd/script/rip_dvd.conf
81 [ -e "${config}" ] && found_config=1 && . "${config}"
82
83 # 3) /etc/rip_dvd.conf
84 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
85
86 # 4) $PWD/rip_dvd.conf
87 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
88
89 # Check to make sure we found the config file
90 if [ $found_config -eq 0 ]; then
91   echo "-E- Unable to find the rip_dvd.conf file: $config"
92   exit 1
93 fi
94
95 ##############################################################################################
96 # Command line processing
97 ##############################################################################################
98 while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j: opt "$@"
99 do
100     case $opt in
101         (n)     dvdname=$OPTARG;;
102         (d)     dest=$OPTARG;;
103         (b)     target_bitrate=$OPTARG;;
104         (s)     target_size=$OPTARG;;
105         (2)     audio_2ch=1;;
106         (1)     force_onepass_mode=1;;
107         (v)     make_final_dest_vob=1;;
108         (i)     make_final_dest_iso=1;;
109         (f)     make_final_dest_folder=1;; 
110         (x)     make_final_dest_comp=1;;
111         (m)     mirror_mode=1;;
112         (k)     keep_intermediate_files=1;;
113         (t)     feature_title_override=$OPTARG;;
114         (a)     aspect=$OPTARG;;
115         (p)     profile=$OPTARG;;
116         (e)     extension=$OPTARG;;
117         (j)     eject_disk=$OPTARG;;
118         (w)     set -$opt;;
119         (h)     show_usage=1;;
120         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
121         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
122     esac
123 done
124
125 shift $((OPTIND-1))
126
127 function usage() {
128     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
129     echo >&2 "Revision $REV"
130     echo >&2 "Options:"
131     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
132     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
133     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
134     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
135     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
136     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
137     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
138     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
139     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
140     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
141     #echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
142     #echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
143     #echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
144     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
145     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
146     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
147     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
148     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
149     echo >&2 "                 The default operation is non-mirror mode where only the main"
150     echo >&2 "                 feature title will be ripped."
151     echo >&2 "   -v            Make the final image a DVD VOB file"
152     echo >&2 "   -i            Make the final image a DVD ISO file"
153     echo >&2 "   -f            Make the final image a DVD folder"
154     echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
155     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
156     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
157     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
158     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
159     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
160     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
161     echo >&2 "   -j <n>        Eject the disk:"
162     echo >&2 "                 - 0 = do not eject the disk"
163     echo >&2 "                 - 1 = eject after the entire script is done (default)"
164     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
165     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
166     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
167     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
168     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
169     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
170     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
171     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
172     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
173     echo >&2 ""
174     exit 2
175 }
176
177 if (($errors)) || (($show_usage))
178 then
179   usage
180 fi
181
182 # Sanity Check - Command Line Options 
183 if [ "$dest" == "" ]; then
184   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
185   usage
186 fi
187
188 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
189   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
190   usage
191 fi
192
193 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
194   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
195   usage
196 fi
197
198 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
199    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
200   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
201   usage
202 fi
203
204 if [ $mirror_mode -eq 1 ]; then
205   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
206      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
207     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
208     usage
209   fi
210 fi
211
212 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
213 if [ "$aspect" != "" ]; then
214   echo "$aspect" | grep -q "x"
215   if [ $? == 0 ]; then
216     echo "-E- You must specify the aspect option with a value whose format is W:H"
217     exit 1
218   fi
219   echo "$aspect" | grep -q ":"
220   if [ $? != 0 ]; then
221     SCALE=",scale -zoom -sws 9 -xy $aspect"
222   else
223     SCALE=",scale=$aspect"
224   fi
225 fi
226
227
228 # Sanity Check - Key executables
229 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
230 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
231 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
232 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
233 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
234 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
235 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
236 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
237
238 ##############################################################################################
239
240 typeset -i ripdvd
241 if [ -z "$dvdname" ]; then
242
243   # make sure the DVD device is accessible
244   volname $dev > /dev/null 2>&1
245   if [ $? != 0 ]; then
246     echo "-E- Can't access the DVD device $dev"
247     exit 1
248   fi
249   # now capture the volume name from the device
250   dvdname=`volname $dev | awk '{ print $1 }'`
251   ripdvd=1
252
253 else 
254
255   # check to see if dvdname is a full path to a real directory
256   # if it is, set dvdname and dvdpath appropriately
257   if [ -d "$dvdname" ]; then
258     dvdpath="$dvdname"
259     dvdname=`basename "$dvdname"`
260     keep_dvdfolder=1
261     if [ -z "$dvdname" ]; then
262      echo "-E- Unable to extract dvdname from path: $dvdpath"
263      exit 1
264     fi
265     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
266       echo "-E- You must supply a full path to a valid DVD folder with this option"
267       exit 1
268     fi
269   fi
270
271   # Check to see if dvdname is a full path to a file
272   if [ -f "$dvdname" ]; then
273     valid_file=0
274
275     # check to see if dvdname is a full path to an MPG2 (VOB) file
276     # if it is, set dvdname and vobfile appropriately
277     file "$dvdname" | grep -q "MPEG"
278     if [ $? == 0 ]; then
279       # It is a valid MPEG2 file, now strip the extension off our dvdname
280       vobfile="$dvdname"
281       dvdname=`basename "$dvdname"`
282       dvdname=${dvdname%.[^.]*}
283       keep_vobfile=1
284       valid_file=1
285     fi
286
287     # check to see if dvdname is a full path to an ISO file
288     # if it is, set dvdname and isofile appropriately
289     file "$dvdname" | grep -q -e "ISO" -e "UDF"
290     if [ $? == 0 ]; then
291       # It is a valid ISO file, now strip the extension off our dvdname
292       isofile="$dvdname"
293       dvdname=`basename "$dvdname"`
294       dvdname=${dvdname%.[^.]*}
295       keep_isofile=1
296       valid_file=1
297     fi    
298
299     # If we didn't find a handler for the file above, complain
300     if [ $valid_file -eq 0 ]; then
301       echo "-E- Unsupported file type: $vobfile"
302       exit 1
303     fi
304
305   # Throw an error if we can't find what the -n option is pointing to
306   else 
307     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
308     exit 1
309   fi
310
311   # Set the ripdvd flag to false since we aren't ripping a DVD disk
312   ripdvd=0
313
314   # Since we aren't ripping a DVD disk, don't eject anything either
315   eject_disk=0
316
317 fi
318
319 # remove bad characters from the dvdname
320 dvdname=${dvdname%.} # remove trailing '.' character
321
322 # add the suffix extension to the end of the dvdname
323 dvdname=$dvdname$extension
324
325 # make a "safe" dvdname (remove special characters)
326 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
327
328 # Make sure we have a non-empty dvdname
329 if [ -z "$dvdname" ]; then
330   echo "-E- unable to determine dvdname"
331   exit 1
332 fi
333
334 # make sure our vobfile value is set
335 if [ -z "$vobfile" ]; then
336   vobfile="$dest/$dvdname.VOB"
337 fi
338
339 # set up some variables to hold various logfiles
340 logfile="$logdir/$dvdname.log"
341 passlogfile="$tmpdir/$safedvdname.log"
342 ddrescuelog=`tempfile`
343 dvdauthorlog=`tempfile`
344 encodelog=`tempfile`
345 dumplog=`tempfile`
346
347 # create the tmpdir if it doesn't already exist
348 if [ ! -d "$tmpdir" ]; then
349   mkdir -p "$tmpdir"
350   if [ $? != 0 ]; then
351     echo "-E- Unable to create the tmpdir: $tmpdir"
352     exit 1
353   fi
354 fi
355
356 # create the logdir if it doesn't already exist
357 if [ ! -d "$logdir" ]; then
358   mkdir -p "$logdir"
359   if [ $? != 0 ]; then
360     echo "-E- Unable to create the logdir: $logdir"
361     exit 1
362   fi
363 fi
364
365 ##############################################################################################
366 # cleanup functions
367 ##############################################################################################
368 cleanup() { 
369   if [ $keep_intermediate_files -eq 0 ]; then
370     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
371     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
372     [[ -e "$encodelog" ]] && rm -f "$encodelog"
373     [[ -e "$dumplog" ]] && rm -f "$dumplog"
374   else
375     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
376     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
377     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
378     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
379   fi
380   echo ""
381 }
382
383 fatal_and_exit() {
384   if [[ -z "$1" ]]; then
385     msg="-E- control-c killed us"
386   else
387     msg=$1
388   fi
389   echo -e 2>&1 "$msg" | tee -a "$logfile"
390   if [[ -n "$mailto" ]]; then
391     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
392   fi
393   keep_intermediate_files=1
394   exit 1
395 }
396
397 # Call our cleanup functions on INT and EXIT signals
398 trap fatal_and_exit INT
399 trap cleanup EXIT
400
401 ##############################################################################################
402 # processing functions
403 ##############################################################################################
404
405 # encode the vob file into a compressed file format
406 function encode_vob_file {
407
408   # Set a variable that we will use later to determine if we found a handler for $profile or not
409   typeset -i found_profile=0
410
411   # For a given profile, to override the 2 pass behavior to be single pass,
412   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
413   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
414   PASSES="1 2"
415
416   # Declare our default 2 pass variables
417   passlogfile_opt="-passlogfile $passlogfile"
418   pass_opt="pass=%PASS"
419
420   # Check the global force_onepass_mode. If it is set, change our variables appropriately
421   # to force 1-pass encoding across all profiles.
422   if [ $force_onepass_mode -eq 1 ]; then
423     PASSES="2"
424     passlogfile_opt=""
425     pass_opt=""    
426   fi
427
428   # XVID profile
429   if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
430     found_profile=1
431     final_output_file="$dest/$dvdname.avi"
432     mencoder_general_opts="$lang_opts $passlogfile_opt"
433     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
434     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
435     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
436
437     # Very High Quality (16fps)
438     if [ "$profile" == "xvidvhq" ]; then
439       video_encoder_opts[0]="bitrate=$target_bitrate"
440       video_encoder_opts[1]="threads=$mencoder_threads"
441       video_encoder_opts[2]="chroma_opt"
442       video_encoder_opts[3]="vhq=4"
443       video_encoder_opts[4]="bvhq=1"
444       video_encoder_opts[5]="quant_type=mpeg"
445       video_encoder_opts[6]="autoaspect"
446     fi
447     # High Quality (20fps)
448     if [ "$profile" == "xvidhq" ]; then
449       video_encoder_opts[0]="bitrate=$target_bitrate"
450       video_encoder_opts[1]="threads=$mencoder_threads"
451       video_encoder_opts[2]="chroma_opt"
452       video_encoder_opts[3]="vhq=2"
453       video_encoder_opts[4]="bvhq=1"
454       video_encoder_opts[5]="quant_type=mpeg"
455       video_encoder_opts[6]="autoaspect"
456     fi
457     # Fast (28fps)
458     if [ "$profile" == "xvid" ]; then
459       video_encoder_opts[0]="bitrate=$target_bitrate"
460       video_encoder_opts[1]="threads=$mencoder_threads"
461       video_encoder_opts[2]="vhq=0"
462       video_encoder_opts[3]="turbo"
463       video_encoder_opts[4]="autoaspect"
464     fi
465
466     for OPTS in "${video_encoder_opts[@]}"; do 
467       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
468     done
469
470     if [ $audio_2ch -eq 0 ]; then
471       # These options produce good 6 channel audio for linux and windows
472       mencoder_audio_opts="-oac copy"
473       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
474       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
475       mencoder_audioch_opts[1]="-af channels=6"
476       mencoder_audioch_opts[2]=""
477     else
478       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
479       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
480       mencoder_audioch_opts[0]=""
481     fi
482  
483   fi
484
485   # MP4 encoding profiles
486   # These are currently in BETA. They don't work that great. A new recipe is needed, for the audio.
487   if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
488     found_profile=1
489     final_output_file="$dest/$dvdname.mp4"
490     mencoder_general_opts="$lang_opts $passlogfile_opt"
491     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
492     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
493     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
494
495     # Very High Quality (6fps)
496     if [ "$profile" == "mp4vhq" ]; then
497       video_encoder_opts[0]="bitrate=$target_bitrate"
498       video_encoder_opts[1]="threads=$mencoder_threads"
499       video_encoder_opts[2]="subq=6"
500       video_encoder_opts[3]="frameref=5"
501       video_encoder_opts[4]="bframes=3"
502       video_encoder_opts[5]="8x8dct"
503       video_encoder_opts[6]="me=umh"
504       video_encoder_opts[7]="b_pyramid"
505       video_encoder_opts[8]="weight_b"
506       video_encoder_opts[9]="partitions=all" 
507     fi
508     # High Quality (13fps)
509     if [ "$profile" == "mp4hq" ]; then
510       video_encoder_opts[0]="bitrate=$target_bitrate"
511       video_encoder_opts[1]="threads=$mencoder_threads"
512       video_encoder_opts[2]="subq=5"
513       video_encoder_opts[3]="frameref=2"
514       video_encoder_opts[4]="bframes=3"
515       video_encoder_opts[5]="8x8dct"
516       video_encoder_opts[6]="b_pyramid"
517       video_encoder_opts[7]="weight_b"
518     fi
519     # Fast (17fps)
520     if [ "$profile" == "mp4" ]; then
521       video_encoder_opts[0]="bitrate=$target_bitrate"
522       video_encoder_opts[1]="threads=$mencoder_threads"
523       video_encoder_opts[2]="subq=4"
524       video_encoder_opts[3]="bframes=2"
525       video_encoder_opts[4]="b_pyramid"
526       video_encoder_opts[5]="weight_b"
527     fi
528
529     for OPTS in "${video_encoder_opts[@]}"; do
530       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
531     done
532
533     if [ $audio_2ch -eq 0 ]; then
534       # These options produce good 6 channel audio for linux and windows
535       #mencoder_audio_opts="-oac copy"
536       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
537       #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
538       #mencoder_audioch_opts[1]="-af channels=6"
539       #mencoder_audioch_opts[2]=""
540       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
541       mencoder_audioch_opts[0]="-channels 6 -srate 48000 -af volnorm=1"
542     else
543       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
544       #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
545       #mencoder_audioch_opts[0]=""
546       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
547       mencoder_audioch_opts[0]="-channels 2 -srate 48000 -af volnorm=1"
548     fi
549
550   fi
551
552   # iphone and ipod MP4 profiles
553   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
554     found_profile=1
555     if [ "$profile" == "iphone" ]; then
556       # SCALE: 480x320
557       # scale width to 480, set height appropriately, but keep a multiple of 16
558       #SCALE=",scale=480:-10"
559       # scale the video down however far is necessary to fit in 480x320
560       SCALE=",dsize=480:320:0,scale=-8:-8"
561     else
562       # SCALE: 320x240
563       # scale width to 320, set height appropriately, but keep a multiple of 16
564       #SCALE=",scale=320:-10"
565       # scale the video down however far is necessary to fit in 320x240
566       SCALE=",dsize=320:240:0,scale=-8:-8"
567     fi
568     final_output_file="$dest/$dvdname.mp4"
569     mencoder_general_opts="$lang_opts $passlogfile_opt"
570     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
571     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
572     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
573     video_encoder_opts[0]="bitrate=$target_bitrate"
574     video_encoder_opts[1]="threads=$mencoder_threads"
575     video_encoder_opts[2]="vbv_maxrate=1500"
576     video_encoder_opts[3]="vbv_bufsize=2000"
577     video_encoder_opts[4]="nocabac"
578     video_encoder_opts[5]="me=umh"
579     video_encoder_opts[6]="subq=6"
580     video_encoder_opts[7]="frameref=6"
581     video_encoder_opts[8]="trellis=1"
582     video_encoder_opts[9]="level_idc=30"
583     video_encoder_opts[10]="global_header"
584     video_encoder_opts[11]="bframes=0"
585     video_encoder_opts[12]="partitions=all"
586     for OPTS in "${video_encoder_opts[@]}"; do 
587       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
588     done
589
590     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
591     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
592   fi
593
594   if [ $found_profile -eq 0 ]; then
595     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
596   fi
597
598   # Do not edit this line. $mencoder_video_encoder_opts must be last
599   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
600   mencoder_retval=0
601
602   for PASS in $PASSES
603   do 
604     # Set some options based on which pass we are in
605     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
606     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
607     [ $PASS -eq 1 ] && output_file="/dev/null"
608     [ $PASS -eq 2 ] && output_file="$final_output_file"
609   
610     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
611     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
612     do
613       echo -e "   Encoding pass $PASS"
614       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
615       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
616       mencoder_retval=$? 
617       grep -q "\[channels\] Invalid" $encodelog
618       if [ $? != 0 ]; then          
619         break;
620       else
621         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
622       fi
623     done
624       
625     if [ $mencoder_retval != 0 ]; then
626       fatal_and_exit "-E- Unhandled mencoder error"
627     fi
628
629     # Concatenate the encode log to our main log file, greping out unwanted lines
630     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
631
632   done
633 }
634
635 function make_dvd_iso_image {
636
637   isofile="$1"
638
639   # check to see if we have a dvdpath to rip from instead of $dev
640   if [ -z "$dvdpath" ]; then
641     # load the CSS codes in the DVD drive 
642     lsdvd $dev >> "$logfile"
643     if [ $? != 0 ]; then
644       fatal_and_exit "-E- lsdvd $dev failed" 
645     fi
646
647     # read the DVD, ignoring/skipping CRC errors
648     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
649     if [ $? != 0 ]; then
650       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
651     fi
652     cat "$ddrescuelog" >> "$logfile"
653   else
654     # rip from a path instead
655     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
656   fi
657 }
658
659 function make_dvd_iso_image_from_folder {
660   
661   src="$1"
662   dst="$2"
663   handle_error=$3
664   
665   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
666
667   # make an iso image out of our directory
668   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
669   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
670
671   # set the audio languages from the iso if it exists and is non-zero in size
672   if [ -s "$dst" ]; then
673     get_feature_title "$dst"
674     get_audio_id_from_iso "$dst"
675   fi
676
677   # make sure we were able to create the iso image from the folder given to us
678   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
679     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
680     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
681     # remove the bad iso file
682     [[ -e "$dst" ]] && rm -f "$dst"
683     # get the feature title from the DVD folder
684     get_feature_title "$dvdpath"
685     # create our main VOB file from the ISO
686     create_main_vob_with_mplayer "$dvdpath" 
687     # get our audio id from the VOB file
688     get_audio_id_from_vob "$vobfile"
689   fi
690 }
691
692 function make_dvdbackup_folder_image {
693   # extract the feature title from the DVD image
694   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
695   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
696   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
697   if [ $? != 0 ]; then
698     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
699   fi
700 }
701
702 function make_dvdauthor_folder_image {
703   # create a new DVD video of the feature title
704   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
705   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
706   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
707   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
708
709   # There is a chance that dvdauthor won't like some of the VOBs.
710   # We can't tell ahead of time which ones it will choke on. 
711   # So, we need to run it over and over again until it can process
712   # all the VOBs. If it can't handle one of them, run it through
713   # mencoder to fix it and try again. These errors are typically
714   # present due to the copy protection that ddrescue removed.
715   grep -q "SCR moves" $dvdauthorlog
716   while [ $? == 0 ]; do
717     # fix bad vobs that get the "SCR moves backwards" error:
718     #  STAT: Processing VTS_01_0.VOB...
719     #  ERR:  SCR moves backwards, remultiplex input.
720     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
721     if [[ ! -f "$badvob" ]]; then
722       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
723     fi
724     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
725     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
726     mv -f $badvob.fixed $badvob
727     echo "-> Creating DVD video $dest/$dvdname"
728     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
729     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
730     grep -q "SCR moves" $dvdauthorlog
731   done
732 }
733
734 function get_feature_title {
735   source="$1"
736   # if a feature title was given on the command line, use it
737   if [ $feature_title_override -ne 0 ]; then
738     feature_title=$feature_title_override
739     return 0
740   fi
741   # otherwise, use lsdvd to figure it out
742   if [ $ripdvd -eq 1 ]; then
743     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
744   else 
745     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
746   fi
747 }
748
749 function create_main_vob_with_cat {
750   # cd to the feature title DVD folder
751   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
752   if [ $? != 0 ]; then
753     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
754   fi
755
756   # concatenate all the VOBs together into 1 giant VOB
757   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
758   cat $vobs > "$tmpdir/$dvdname.VOB"
759
760   # cd back to the dir we started from
761   popd > /dev/null 2>&1
762 }
763
764 function create_main_vob_with_mplayer {
765
766   # argument processing  
767   source="$1"
768   remove_dumplog=$2
769
770   # make sure we have a valid feature title
771   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
772     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
773   fi
774
775   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
776   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
777     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
778     msg="$msg We also detected another condition that requires us to use dumpstream. "
779     msg="$msg\n    Unable to rip this DVD in the mode you requested."
780     fatal_and_exit "$msg"
781   fi
782
783   # use mplayer to create the main VOB file
784   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
785   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
786   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
787   if [ $? != 0 ]; then
788     cat $dumplog | grep -v "^A:" >> "$logfile"
789     fatal_and_exit "-E- Mplayer Failed"
790   fi
791   cat $dumplog | grep -v "^A:" >> "$logfile"
792   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
793 }
794
795 function get_audio_id_from_iso {
796   # Adjust our audio ID to find the english audio stream
797   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
798   iso="$1"
799   aidcheck=`tempfile`
800   aid=128
801   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
802   grep -q "aid: $aid" $aidcheck
803   while [ $? == 1 ] && [ $aid -lt 159 ]; do
804     (( aid = aid + 1 ))
805     grep -q "aid: $aid" $aidcheck
806   done
807   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
808   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
809   # mencoder default DVD audio track language selection (english)
810   lang_opts="-aid $aid -alang en"
811 }
812
813 function get_crop_from_iso { 
814   FRAMES=10000
815   echo "-> Detecting black frame border crop value from ISO file"
816   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
817   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
818   [[ -e "md5sums" ]] && rm -f "md5sums"
819   CROP=`cat $dumplog | grep CROP | tail -1`
820   echo "   Found crop value of $CROP" >> "$logfile"
821   CROP=${CROP#* crop=}
822   CROP=${CROP%%\).*}
823   typeset -i CROPCHECK
824   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
825   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
826   if [ -z "$CROP" ]; then
827     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
828     return
829   fi
830   if [ $CROPCHECK -lt 0 ]; then 
831     CROP=""
832   else 
833     CROP=",crop=$CROP"
834   fi
835   echo "   Setting mencoder crop filter to: $CROP"
836 }
837
838 function get_crop_from_vob { 
839   FRAMES=10000
840   echo "-> Detecting black frame border crop value from VOB file"
841   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
842   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
843   [[ -e "md5sums" ]] && rm -f "md5sums"
844   CROP=`cat $dumplog | grep CROP | tail -1`
845   echo "   Found crop value of $CROP" >> "$logfile"
846   CROP=${CROP#* crop=}
847   CROP=${CROP%%\).*}
848   typeset -i CROPCHECK
849   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
850   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
851   if [ -z "$CROP" ]; then
852     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
853     return
854   fi
855   if [ $CROPCHECK -lt 0 ]; then 
856     CROP=""
857   else 
858     CROP=",crop=$CROP"
859   fi
860   echo "   Setting mencoder crop filter to: $CROP"
861 }
862
863 function get_audio_id_from_vob {
864   # Adjust our audio ID to find the english audio stream
865   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
866   vob="$1"
867   aidcheck=`tempfile`
868   aid=128
869   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
870   grep -q "Found audio stream: $aid" $aidcheck
871   while [ $? == 1 ] && [ $aid -lt 159 ]; do
872     (( aid = aid + 1 ))
873     grep -q "Found audio stream: $aid" $aidcheck
874   done
875   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
876   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
877   # mencoder default DVD audio track language selection (english)
878   lang_opts="-aid $aid -alang en"
879 }
880
881 function check_vob_for_corrupted_start {
882   # check to see if the beginning of the DVD has a form of copy protection
883   # where they have deliberately broken the first X number of frames of the DVD.
884   # If we don't skip these, our resulting VOB file will not play.
885   badvobcheck=`tempfile`
886   endpos=360
887   skip=0
888   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
889   if [ $? != 0 ]; then
890     fatal_and_exit "-E- Mencoder Failed"
891   fi
892   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
893   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
894     (( skip = skip + 5 ))
895     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
896     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
897     if [ $? != 0 ]; then
898       fatal_and_exit "-E- Mencoder Failed"
899     fi
900     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
901   done
902   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
903
904   # cat the giant VOB into mencoder to create a playable VOB file
905   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
906   if [ $? != 0 ]; then
907     fatal_and_exit "-E- Mencoder Failed"
908   fi
909 }
910
911 function check_vob_for_completeness {
912   # check to make sure we got out a complete VOB.
913   # there is another kind of copy protection where the VOB's may
914   # have "MPG EOF" frames in the middle of the stream. 
915   # this causes mencoder to not process the entire VOB, and exit without any errors.
916   # detect this by seeing how much smaller the dst vob is from the src vob.
917   MAX_FILESIZE_DELTA_PERCENT=70
918   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
919   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
920   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
921   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
922     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
923     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
924     create_main_vob_with_mplayer "$isofile"
925     [[ -e "$dumplog" ]] && rm -f $dumplog
926     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
927     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
928     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
929       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
930     fi
931   fi
932 }
933
934 function check_vob_for_too_many_video_packets {
935   # If our earlier algorithm to work around this failed, throw an error.
936   # check to see if this DVD has a protection scheme we don't know how to work around
937   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
938   # for some reason, the video is black, while the audio rolls, then the video finally comes
939   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
940   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
941   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
942   grep -q "Too many video packets in the buffer:" "$logfile"
943   if [ $? == 0 ]; then
944     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
945     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
946     create_main_vob_with_mplayer "$isofile"
947     grep -q "Too many video packets in the buffer:" $dumplog
948     if [ $? == 0 ]; then
949       [[ -e "$dumplog" ]] && rm -f $dumplog
950       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
951     fi
952     [[ -e "$dumplog" ]] && rm -f $dumplog
953   fi
954 }
955
956 function check_vob_for_a52_crc_errors {
957   # Let's see if we can playback our newly created VOB file without any errors.
958   # if there are issues, let's detect them now, and try to recreate the VOB
959   # there are some forms of copy protection that have missed above, that evidence
960   # themselves when we try to playback the VOB file. This was added to deal with
961   # the "a52: CRC check failed" copy protection scheme.
962   MAX_ERRORS=10
963   ENDPOS=120
964   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
965   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
966   cat $dumplog | grep -v "^A:" >> "$logfile"
967   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
968   if [ $errors -gt $MAX_ERRORS ]; then
969     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
970     create_main_vob_with_mplayer "$isofile"
971     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
972     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
973     if [ $? != 0 ]; then
974       cat $dumplog | grep -v "^A:" >> "$logfile"
975       fatal_and_exit "-E- Mplayer Failed"
976     fi
977     cat $dumplog | grep -v "^A:" >> "$logfile"
978     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
979     if [ $errors -gt $MAX_ERRORS ]; then
980       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
981     fi
982   fi
983   [[ -e "$dumplog" ]] && rm -f $dumplog
984 }
985
986 function calculate_bitrate_from_target_size {
987   # determine what our bitrate needs to be if a target size was specified instead
988   if [ $target_size -ne 0 ]; then
989     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
990     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
991     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
992   fi
993 }
994
995 function create_dvdauthor_dvd_xml_file {
996   # make a dvdauthor xml menu file to create a valid DVD video from 
997   # this script does a good job, but we'll still need to clean it up a bit after it runs
998   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
999   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1000   if [ $? != 0 ]; then
1001     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1002   fi
1003
1004   # replace the first line of the xml file to remove the bad dest path
1005   awk -v line=1 -v new_content="<dvdauthor>" '{
1006     if (NR == line) {
1007       print new_content;
1008     } else {
1009       print $0;
1010     }
1011   }' dvd.xml > dvd.xml.new
1012   mv -f dvd.xml.new dvd.xml
1013   if [ $? != 0 ]; then
1014     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1015   fi
1016
1017   # remove the "<video " property line from the xml file
1018   cat dvd.xml | grep -v "<video" > dvd.xml.new
1019   mv -f dvd.xml.new dvd.xml
1020   if [ $? != 0 ]; then
1021     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1022   fi
1023   
1024   # remove the extra <pgc>..</pgc> pairs
1025   cat dvd.xml | awk 'BEGIN {x=1}
1026   {
1027     if ($0~"</pgc>") {x=0}
1028     if (x==1) {print $0}
1029     if ($0~"<pgc>") {x=1}
1030   }' > dvd.xml.new
1031   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1032   mv -f dvd.xml.new dvd.xml
1033   if [ $? != 0 ]; then
1034     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1035   fi
1036
1037   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1038   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1039   mv -f dvd.xml.new dvd.xml
1040   if [ $? != 0 ]; then
1041     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1042   fi
1043 }
1044
1045 function check_for_mplayer_dumpstream_incompatibility {
1046
1047   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1048
1049   if [ ! -e "$vobfile" ]; then
1050     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1051     # A DVD that has 99 titles, where the longest title isn't the main feature
1052     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1053     # out what the feature title is. This script will run through that flow if we
1054     # set use_mplayer_dumpstream to 0. Check for this here.
1055     if [ $ripdvd -eq 1 ]; then
1056       lsdvd $dev | grep -q "Title: 99"
1057     else
1058       lsdvd "$isofile" | grep -q "Title: 99"
1059     fi
1060     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1061     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1062       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1063         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1064         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1065         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1066         invalid_feature_title=1
1067       else 
1068         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1069         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1070         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1071         use_mplayer_dumpstream=0
1072         invalid_feature_title=1
1073       fi
1074       return
1075     fi
1076   fi
1077
1078   # There is another form of protection that causes the mplayer dumpstream to fail. 
1079   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1080   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1081   # problem before continuing.
1082   if [ -e "$vobfile" ]; then
1083     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1084     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1085     grep -q "Too many audio packets in the buffer" $dumplog
1086     if [ $? == 0 ]; then
1087       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1088       use_mplayer_dumpstream=0
1089       mplayer_dumpstream_incompatibility=1
1090     fi
1091     [[ -e "$dumplog" ]] && rm -f $dumplog
1092   fi
1093 }
1094
1095 function fill_mythvideo_metadata {
1096
1097   # This function must be passed the filename as an argument
1098   # The filename must be a full path to the file
1099   filename="$1"
1100
1101   # Make sure the fill mythvideo metadata option has been set to 1
1102   if [ $fill_mythvideo_metadata -eq 0 ]; then
1103     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1104     return 0
1105   fi
1106
1107   # If the fill mythvideo metadata script is present, run it
1108   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1109   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1110     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1111     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1112   else
1113     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1114     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1115   fi
1116 }
1117
1118 # remove the intermediate VOB file
1119 function remove_intermediate_vob_file {
1120   if [ $keep_intermediate_files -eq 0 ]; then
1121     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1122   else
1123     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1124   fi
1125 }
1126
1127 # remove the original DVD image 
1128 function remove_intermediate_iso_file {
1129   [[ $keep_isofile -eq 1 ]] && return 1
1130   if [ $keep_intermediate_files -eq 0 ]; then
1131     [[ -e "$isofile" ]] && rm "$isofile"
1132   else
1133     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1134   fi
1135 }
1136
1137 # remove the intermediate dvdbackup folder
1138 function remove_intermediate_dvdbackup_folder {
1139   if [ $keep_intermediate_files -eq 0 ]; then
1140     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1141   else
1142     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1143   fi
1144 }
1145
1146 ##############################################################################################
1147 # MAIN
1148 ##############################################################################################
1149
1150 # Make a note of when this DVD rip started
1151 date=`date`
1152 echo -e "\n$date DVD rip started" >> "$logfile"
1153 echo "$cmd" >> "$logfile"
1154
1155 # Rip the DVD - Mirror Mode
1156 if [ $mirror_mode -eq 1 ]; then
1157   echo "-> Ripping DVD $dvdname to $dest"
1158
1159   # use ddrescue to make an ISO image of the disk
1160   make_dvd_iso_image "$dest/$dvdname.iso"
1161
1162   # add this video data to the mythtv DB
1163   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1164
1165   # eject the disk upon completion
1166   if [ $eject_disk -ne 0 ]; then
1167     eject -T $dev
1168   fi
1169
1170   date=`date`
1171   echo "$date DVD rip completed" | tee -a "$logfile"
1172
1173   if [[ -n "$mailto" ]]; then
1174     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1175   fi
1176
1177 fi
1178
1179 # Rip the DVD - Main Title Feature Only
1180 if [ $mirror_mode -eq 0 ]; then
1181
1182   # Rip image from DVD
1183   if [ $ripdvd -eq 1 ]; then
1184     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1185     # use ddrescue to make an ISO image of the disk
1186     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1187   fi
1188
1189   # Rip image from DVD path
1190   if [ -n "$dvdpath" ]; then
1191     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1192     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1193   fi
1194
1195   # make sure our isofile value is set
1196   if [ -z "$isofile" ]; then
1197     isofile="$tmpdir/$dvdname.iso"
1198   fi
1199      
1200   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1201
1202     if [ ! -e "$vobfile" ]; then
1203       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1204       
1205       # get the feature title from the ISO
1206       get_feature_title "$isofile"
1207  
1208       # get the crop value from the ISO
1209       get_crop_from_iso
1210
1211       # check for mplayer dumpstream incompatibilities
1212       # if they exist, this method will set this mode to 0.
1213       check_for_mplayer_dumpstream_incompatibility
1214
1215       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1216
1217         # get our audio id from the ISO file
1218         get_audio_id_from_iso "$isofile"
1219
1220         # create our main VOB file from the ISO
1221         create_main_vob_with_mplayer "$isofile"
1222      
1223         # remove the intermediate VOB file
1224         remove_intermediate_vob_file
1225
1226         # it's possible that our VOB is still corrupted in some manner
1227         # check to make sure it is still a good VOB before continuing.
1228         check_for_mplayer_dumpstream_incompatibility
1229
1230       fi
1231  
1232       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1233
1234         # use dvdbackup to make a DVD folder of the feature title
1235         make_dvdbackup_folder_image
1236   
1237         # create our main VOB file
1238         create_main_vob_with_cat
1239
1240         # get our audio id from the VOB file
1241         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1242   
1243         # check for corrupted VOB start
1244         check_vob_for_corrupted_start
1245  
1246         # check to make sure our VOB is complete
1247         check_vob_for_completeness
1248
1249         # check to make sure our VOB doesn't have too many video packets
1250         check_vob_for_too_many_video_packets
1251
1252         # check to make sure our VOB doesn't have a52 crc errors
1253         check_vob_for_a52_crc_errors
1254
1255         # remove the intermediate VOB file
1256         remove_intermediate_vob_file
1257
1258       fi
1259
1260       # remove the intermediate ISO file
1261       remove_intermediate_iso_file
1262
1263     else
1264       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1265       # get our audio id from the VOB file
1266       get_audio_id_from_vob "$vobfile"
1267       # get the crop value from the VOB
1268       get_crop_from_vob
1269     fi
1270
1271     # eject the DVD disk since we are finished with it
1272     [ $eject_disk -eq 2 ] && eject -T $dev
1273
1274     # encode the VOB file to a compressed file format
1275     if [ $make_final_dest_comp -eq 1 ]; then
1276       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1277
1278       # determine what our bitrate needs to be if a target size was specified instead
1279       calculate_bitrate_from_target_size        
1280      
1281       # encode the vob file into a compressed file format
1282       encode_vob_file
1283
1284       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1285         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1286         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1287       else
1288         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1289         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1290       fi
1291     fi
1292
1293   # add this video data to the mythtv DB
1294   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1295   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1296     
1297   else
1298
1299   # use dvdbackup to make a DVD folder of the feature title
1300   make_dvdbackup_folder_image
1301
1302   # cd to the feature title DVD folder
1303   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1304   if [ $? != 0 ]; then
1305     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1306   fi
1307   
1308   # create the dvd.xml file for dvdauthor
1309   create_dvdauthor_dvd_xml_file  
1310
1311   # make the final DVD folder image
1312   make_dvdauthor_folder_image
1313
1314   # add this video data to the mythtv DB
1315   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1316  
1317   # cd back to the dir we started from
1318   popd > /dev/null 2>&1
1319
1320   if [ $make_final_dest_iso -eq 1 ]; then
1321
1322     # make an iso image out of our directory
1323     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1324    
1325     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1326     if [ -s "$dest/$dvdname.iso" ]; then
1327       if [ $make_final_dest_folder -eq 0 ]; then
1328         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1329         # remove the folder of the DVD image now that we have a .iso version of it
1330         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1331       fi
1332     else
1333       # we created an empty iso file, remove it
1334       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1335       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1336       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1337     fi
1338  
1339     # add this video data to the mythtv DB
1340     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1341
1342   fi
1343
1344   fi
1345
1346   # remove the ddrescue DVD ISO image
1347   remove_intermediate_iso_file
1348
1349   # remove the tmp dvdbackup folder of the DVD image
1350   remove_intermediate_dvdbackup_folder
1351
1352   # eject the DVD disk upon completion
1353   [ $eject_disk -eq 1 ] && eject -T $dev
1354
1355   date=`date`
1356   echo "$date DVD rip completed" | tee -a "$logfile"
1357
1358   if [[ -n "$mailto" ]]; then
1359     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1360   fi
1361
1362 fi
1363
1364 ##############################################################################################